unit UWatchTest;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls,Watch, ExtCtrls;

type
  TForm1 = class(TForm)
    lb: TListBox;
    Panel1: TPanel;
    Watch1: TWatch;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    bExit: TButton;
    bClear: TButton;
    CheckBox3: TCheckBox;
    procedure bExitClick(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure CheckBox3Click(Sender: TObject);
    procedure lbDblClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Watch1ActivateShellWindow(Sender: TObject; Handle: Integer;
      AppName: String);
    procedure Watch1KeyNative(Sender: TObject; wParam, lParam: Integer);
    procedure Watch1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Watch1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Watch1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Watch1WindowActivated(Sender: TObject; Handle: Integer;
      AppName: String);            
    procedure Watch1WindowCreated(Sender: TObject; Handle: Integer;
      AppName: String);
    procedure Watch1WindowDestroyed(Sender: TObject; Handle: Integer;
      AppName: String);
  private
    { Private declarations }
    procedure output(const s:String);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.output(const s:String);
begin
 lb.Items.Add(s);
 lb.TopIndex:=lb.Items.count-1;
end;

procedure TForm1.bExitClick(Sender: TObject);
begin
 Close;
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
 if (Sender as TCheckBox).checked then
  Watch1.Start(wtShell)
 else
  Watch1.Stop(wtShell);
end;

procedure TForm1.CheckBox2Click(Sender: TObject);
begin
 if (Sender as TCheckBox).checked then
  Watch1.Start(wtKeyboard)
 else
  Watch1.Stop(wtKeyboard);
end;

procedure TForm1.lbDblClick(Sender: TObject);
begin
 lb.items.clear;
end;

procedure TForm1.CheckBox3Click(Sender: TObject);
begin
 if (Sender as TCheckBox).checked then
  Watch1.Start(wtMouse)
 else
  Watch1.Stop(wtMouse);
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 Watch1.Free;
end;

procedure TForm1.Watch1ActivateShellWindow(Sender: TObject;
  Handle: Integer; AppName: String);
begin
 output('Activated Shell "'+AppName+'"');
end;

procedure TForm1.Watch1KeyNative(Sender: TObject; wParam,
  lParam: Integer);
var ki:TKeyInfo;
const bool:Array[Boolean] of string=('False', 'True');
begin
 Watch1.getKeyInfo(lParam,ki);
 lb.Items.Add('Key '+Watch1.getVKString(wParam)+' ,'+IntToHex(lParam,8));
 lb.Items.Add('    Repeat:'+IntToStr(ki.RepeatCount)
              +' Scan Code:'+IntToStr(ki.ScanCode)
              +' Extended:'+bool[ki.Extended]
              +' Alt:'+bool[ki.AltDown]
              +' PrevDown:'+bool[ki.PreviousDown]
              +' Down:'+bool[ki.Down]
              +' Name:'+ki.KeyNameText);
 LB.TopIndex:=LB.Items.count-1;
end;

const
 B2S:Array[TMouseButton] of String=('Left', 'Right', 'Middle');

function isDouble(Shift:TShiftState):String;
begin
 if ssDouble in Shift then
  result:='Double'
 else
  result:='';
end;

procedure TForm1.Watch1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 output(format('Mouse down at %d,%d Button: %s %s', [X,Y,B2S[Button], isDouble(Shift)]));
end;

procedure TForm1.Watch1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
 output(format('Mouse move at %d,%d', [X,Y]));
end;

procedure TForm1.Watch1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 output(format('Mouse up at %d,%d Button: %s %s', [X,Y,B2S[Button], isDouble(Shift)]));
end;

procedure TForm1.Watch1WindowActivated(Sender: TObject; Handle: Integer;
  AppName: String);
begin
 output('Activated "'+AppName+'"');
end;

procedure TForm1.Watch1WindowCreated(Sender: TObject; Handle: Integer;
  AppName: String);
begin
 output('Created "'+AppName+'"');
end;

procedure TForm1.Watch1WindowDestroyed(Sender: TObject; Handle: Integer;
  AppName: String);
begin
 output('Destroyed "'+AppName+'"');
end;

end.
